#pragma rtGlobals=1		// Use modern global access method.

Function CORR_Correlation(): graphMarquee //160203
	String ctrlname
	// set datafolder
	String dfStr=SIS_getDataFolderName() // where image is stored
	SetDataFolder root:$(dfStr)
	String imageStr=SIS_getImageStackName() // image name
	String winStr=SIS_getWinName() // nome della finestra
	// input
	variable type=2
	Prompt type, "type", popup "correlation FFT; autocorrelation; correlation"
	variable fov=2
	Prompt fov, "enter Field of View (microns)"
	variable binning=1
	Prompt binning, "enter binning (nxn)"
	doPrompt "FoV and binning" type, fov, binning
	if (V_Flag==0)
		GetMarquee/Z/K left, top
		variable pLT,pRB,qLT,qRB
		if (V_Flag == 0)
			Print "There is no marquee"
		else
			pLT=round(V_top)
			pRB=round(V_bottom)
			qLT=round(V_left)
			qRB=round(V_right)
			// duplicate wave in tmp
			String tmpStr=imageStr[0,strlen(imageStr)-4]+"TMP"
			String acrStr=imageStr[0,strlen(imageStr)-4]+"ACR"
			String gfStr=imageStr[0,strlen(imageStr)-4]+"GFN"
			String graph1Str="GT"+imageStr[0,strlen(imageStr)-4]
			String graph2Str="CR"+imageStr[0,strlen(imageStr)-4]
			String graph3Str="GF"+imageStr[0,strlen(imageStr)-4]
			duplicate/O $imageStr $tmpStr			
			SIS_redimensionImage(tmpStr, pLT, pRB, qLT, qRB)
			// debug 
			variable np=dimSize($tmpStr,0)
			variable nq=dimSize($tmpStr,1)
			make/n=(2*(np/2)+1)/o acr1,acr2
			if (type==2)
				make/n=(2*(np/2)+1)/o $acrStr
				wave acorrw=$acrStr
			endif
			if (type==3)
				make/n=(2*(np/2)+1)/o $gfStr
				wave gfuncw=$gfStr
			endif
					
			variable i=0
			do
				CORR_extractProfile($tmpStr,i,acr1)
				
				if (type==1)
					CORR_elation2(acr1,acr2)
					FFT/dest=wf_FFT/out=3 acr2
					acorrw+=wf_FFT
				endif
				
				if (type==2)
					wavestats/Q  acr1
					acr1-=V_rms
					duplicate/o acr1 acr2
					Correlate/AUTO acr1, acr2
					if (i==0)
						acorrw=0
						duplicate/o acr2 acorrw
					else
						acorrw+=acr2
					endif						
				endif
				
				if (type==3)
					if (i==0)
						gfuncw=0
					endif
					CORR_elation1(acr1,acr2)
					gfuncw+=acr2
				endif
		
				i+=1
				doUpdate
			while (i<nq)

			if (type==1)
				np=numpnts($acrStr)/2
				SetScale/I x 0,2/(1000*fov/(870/binning)),"", $acrStr
				SIS_waveToFront(graph1Str,acrStr)
				ModifyGraph mirror=1
				ModifyGraph log(bottom)=1
				ModifyGraph log(left)=1
				SetAxis bottom 3,300
				Label left "\\F'Arial'\\Z18G(x) [a.u.]";DelayUpdate
				Label bottom "\\F'Arial'\\Z18Frequency [nm\S-1\M\\F'Arial'\\Z18]"
				ModifyGraph rgb($acrStr)=(0,0,0)
				ModifyGraph msize=3,marker($acrStr)=19
				ModifyGraph mode($acrStr)=4
	//make/n=3/o W_coef={23,1.4e+05,1.1}
	//FuncFit/H="100" fitG W_coef  $corrstr[2,5] /D 
	//FuncFit/H="011" fitG W_coef  $corrstr[2,60]  /D
				make/n=3/o W_coef={4.4325e+05,8.7726e+06,50}
				CurveFit exp kwCWave=W_coef, $acrStr[2,200]
				variable corrl = W_coef[2]
				W_coef={537590,25757,-1.6}
				CurveFit Power  kwCWave=W_coef, $acrStr[20,200]
				String text="exp PL @ "+num2str(w_coef[2])
				TextBox/C/N=text0/F=0/A=MC text
				SetAxis/A
				String pwrstr = tmpStr+"_PWR"
				Make/n=(1000)/o $pwrstr
				wave pw=$pwrstr
				SetScale/P x 0.001,0.001,"",  $pwrstr
				pw=W_coef[0]+W_coef[1]*x^W_coef[2]
				appendToGraph pw
			endif
			
			if (type==2)
				//duplicate/o cw $corrstr
				np=numpnts($acrStr)/2
				SetScale/P x -np*1000*fov/(870/binning),1000*fov/(870/binning),"", $acrStr
				SIS_waveToFront(graph2Str,acrStr)
				Label left "\\F'Arial'\\Z18Autocorrelation [a.u.]"
				Label bottom "\\F'Arial'\\Z18Distance [nm]"
				SetAxis bottom -200,200 
			endif			
			
			if (type == 3)
				SetScale/P x 0,1000*fov/(870/binning),"", $gfStr
				SIS_waveToFront(graph3Str,gfStr)
				ModifyGraph mirror=1
				ModifyGraph log(bottom)=1
				ModifyGraph log(left)=1
				SetAxis bottom 1,200
				Label left "\\F'Arial'\\Z18G(x) [a.u.]";DelayUpdate
				Label bottom "\\F'Arial'\\Z18Distance [nm]"
				ModifyGraph rgb($gfStr)=(0,0,0)
				ModifyGraph msize=3,marker($gfStr)=19
				ModifyGraph mode($gfStr)=4
				make/n=3/o W_coef={23,1.4e+04,1.1}
				FuncFit/H="100" CORR_fitG W_coef  $gfStr[2,5] /D 
				FuncFit/H="011" CORR_fitG W_coef  $gfStr[2,50]  /D
				String textstr="2H = "+num2str(w_coef[2]) +"\r"+"kink @ "+num2str(w_coef[0])+" nm"
				TextBox/C/N=text0/F=0/A=MC textstr
			endif
			
		endif
	endif
end	


Function CORR_extractProfile(image,index,dest)
	wave image
	variable index
	wave dest
	//dest[] =image[index][p]
	dest[] =image[p][index]
End

Function CORR_elation1(w1,w2)
	wave w1, w2
	duplicate/o w1 wt,w2
	variable np=dimsize(w1,0)
	variable i=0
	do
		//wt[] =(w1[p+i]-w1[p])^2
		//wt[] =abs(w1[p+i]-w1[p])*(w1[p])
		//wavestats/Q w1
		//w1-=V_avg
		wt[] =(w1[p+i])*(w1[p]) 
		w2[i]=sum(wt,0,np-i-1)/(np-i)
		i+=1
	while (i<np)
End

Function CORR_elation2(w1,w2)
	wave w1, w2
	duplicate/o w1 wt,w2
	variable np=dimsize(w1,0)
	variable i=0
	do
		//wt[] =(w1[p+i]-w1[p])^2 //prodcut of the differences (Changes powerlaw)
		// wt[] =(w1[p+i]-w1[p])*(w1[p]) 
		//wavestats/Q w1
		//w1-=V_avg
		wt[] =(w1[p+i])*(w1[p])  // product
		w2[i]=sum(wt,0,np-i-1)/(np-i)
		i+=1
	while (i<np)
End

Function CORR_fitG(w,x) : FitFunc
	wave w
	variable x
	//CurveFitDialog/ w[0] = kink
	//CurveFitDialog/ w[1] = k
	//CurveFitDialog/ w[2] = slope
	if (x<=w[0])
		return w[1]*x^w[2]
	else
		return w[1]*w[0]^w[2]
	endif
end

function CORR_calcWidth():graphMarquee //160203
	String ctrlname
	String waveStr
	Prompt waveStr, "autocorr wave",popup,WaveList("*_ACR",";","WIN:")
	doPrompt "entre wave", waveStr
	if (V_Flag==0)
		GetMarquee/Z/K left, bottom
		variable pLT,pRB,qLT,qRB
		if (V_Flag == 0)
			Print "There is no marquee"
		else
			pLT=round(V_top)
			pRB=round(V_bottom)
			qLT=round(V_left)
			qRB=round(V_right)
			variable q1=x2pnt($waveStr,qLT)
			variable q2=x2pnt($waveStr,qRB)
			make/N=4/o  W_coef
			W_coef[0]=0
			W_coef[1]=abs(pLT-pRB)
			W_coef[2]=0
			W_coef[3]=10
			CurveFit/NTHR=0 gauss $waveStr[q1,q2] /D
			variable w=W_coef[3]*2.35/sqrt(2)
			TextBox/C/N=text0/A=MC "corr lengt ="+num2str(w) 
		endif
	endif
end			

